/*
 File:       allocazione1.c
 Specifica:  allocazione dinamica
 Versioni:   19/2/2001 == versione iniziale
*/

// include header standard
#include <stdio.h>
#include <stdlib.h> // necessaria per la malloc

#define MAX 10

/* il prototipo della malloc e'
       
   void *malloc(size_t size);

  void *         ritorna un puntatore ad tipo indeterminato
  size_t size    size_t e' typedef unsigned long size
*/

int main()
{
  int *p, i; /* p puntatore a intero */

  /* in questo punto p non riferisce alcuno spazio
     allocato, ma contiene un valore indefinito */

  /* allocazione dinamica della memoria
     necessaria a contenere un array di interi */

  p = (int *) malloc( sizeof(int) * MAX ); 

  /* puntatore nullo equivale a errore */
  if( p == NULL ) {
    /* memoria insufficiente */
    printf("Non e' stato possibile allocare memoria!\n");
    return -1;
  }

  /* uso p come un array */
  for(i=0; i < MAX; i++)
  {
    p[i] = i*i;
    printf("p[%d] = %d\n", i, p[i]);
  }

  /* rilascio la memoria allocata */
  free(p);

  /* in questo punto, p non riferisce alcuno 
     spazio di memoria */

  return 0;
}

